#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

void unosProizvodaUTekstualnuDatotekuPrviNacin();
void unosProizvodaUTekstualnuDatotekuDrugiNacin();
void dodavanjeProizvodaUTekstualnuDatoteku();
void citanjeTekstualneDatotekePrviNacin();
void citanjeTekstualneDatotekeDrugiNacin();
void citanjeTekstualneDatotekeTreciNacin();
void citanjeTekstualneDatotekeCetvrtiNacin();

int main(void) {

	//unosProizvodaUTekstualnuDatoteku();
	//unosProizvodaUTekstualnuDatotekuDrugiNacin();
	//dodavanjeProizvodaUTekstualnuDatoteku();
	//citanjeTekstualneDatotekePrviNacin();
	//citanjeTekstualneDatotekeDrugiNacin();
	//citanjeTekstualneDatotekeTreciNacin();
	citanjeTekstualneDatotekeCetvrtiNacin();

	system("pause");
	return 0;
}

void unosProizvodaUTekstualnuDatotekuPrviNacin() {
	char naziv[50];
	double cena;
	char kraj = 'n';

	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "w");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za upisivanje!\n");
		return;
	}

	do {
		printf("Unesite naziv proizvoda:\n");
		gets(naziv);

		fprintf(datoteka,"%s\n", naziv);

		printf("Unesite cenu proizvoda:\n");
		scanf("%lf", &cena);
		getchar();
		fprintf(datoteka, "%.2lf\n", cena);

		printf("Da li zelite da unesete jos proizvoda? [d|n]\n");
		kraj = getchar();
		getchar();
	} while (kraj != 'n');

	fclose(datoteka);
}

void unosProizvodaUTekstualnuDatotekuDrugiNacin() {
	char naziv[50];
	char cena[50];
	char kraj = 'n';

	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "w");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za upisivanje!\n");
		return;
	}

	do {
		printf("Unesite naziv proizvoda:\n");
		gets(naziv);

		//fprintf(datoteka, "%s\n", naziv);
		fputs(naziv, datoteka);
		fputs("\n", datoteka);

		printf("Unesite cenu proizvoda:\n");
		gets(cena);
		
		//fprintf(datoteka, "%.2lf\n", cena);
		fputs(cena, datoteka);
		fputs("\n", datoteka);

		printf("Da li zelite da unesete jos proizvoda? [d|n]\n");
		kraj = getchar();
		getchar();
	} while (kraj != 'n');

	fclose(datoteka);
}

void dodavanjeProizvodaUTekstualnuDatoteku() {
	char naziv[50];
	double cena;
	char kraj = 'n';

	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "a");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za upisivanje!\n");
		return;
	}

	do {
		printf("Unesite naziv proizvoda:\n");
		gets(naziv);

		fprintf(datoteka, "%s\n", naziv);

		printf("Unesite cenu proizvoda:\n");
		scanf("%lf", &cena);
		getchar();
		fprintf(datoteka, "%.2lf\n", cena);

		printf("Da li zelite da unesete jos proizvoda? [d|n]\n");
		kraj = getchar();
		getchar();
	} while (kraj != 'n');

	fclose(datoteka);
}

//znak po znak
void citanjeTekstualneDatotekePrviNacin() {
	char znak;
	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "r");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za citanje!\n");
		return;
	}

	/*
	//na ovaj nacin ce se procitati i EOF, sto nam ne treba!
	while (!feof(datoteka)) {
		znak = fgetc(datoteka);
		printf("%c", znak);
	}
	printf("kraj\n");
	*/

	while ((znak = fgetc(datoteka)) != EOF) {
		printf("%c", znak);
	}
	printf("kraj\n");

	fclose(datoteka);


}
//red po red
void citanjeTekstualneDatotekeDrugiNacin() {
	char red[1000];
	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "r");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za citanje!\n");
		return;
	}

	/*
	//na ovaj nacin ce se citanje nepotrebno vrsiti jos jedan put!
	while (!feof(datoteka)) {
		fgets(red, 1000, datoteka);
		printf("%s", red);
	}
	printf("kraj\n");
	*/
	
	while ((fgets(red, 1000, datoteka)) != NULL) {
		printf("%s", red);
	}
	printf("kraj\n");
	

	fclose(datoteka);


}

//sa konverzijom
void citanjeTekstualneDatotekeTreciNacin() {
	char naziv[50];
	double cena;
	FILE *datoteka;

	datoteka = fopen("proizvodi.txt", "r");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za citanje!\n");
		return;
	}


	while ((fgets(naziv, 50, datoteka)) != NULL) {
		printf("%s", naziv);
		fscanf(datoteka, "%lf\n", &cena);
		printf("%lf\n", cena);
	}
	printf("kraj\n");


	fclose(datoteka);


}

//univerzalno
void citanjeTekstualneDatotekeCetvrtiNacin() {
	char sadrzaj[1000];
	FILE *datoteka;
	int brojProcitanihBajtova;

	datoteka = fopen("proizvodi.txt", "r");
	if (datoteka == NULL) {
		printf("Dogodila se greska prilikom otvaranja datoteke za citanje!\n");
		return;
	}


	while ((brojProcitanihBajtova=fread(sadrzaj,sizeof(char) ,1000, datoteka)) != 0) {
		//printf("%s", sadrzaj); nije string
		fwrite(sadrzaj, sizeof(char), brojProcitanihBajtova, stdout);
	}
	printf("kraj\n");


	fclose(datoteka);


}


